
 /* ======= PROYECTO DE MICROCONTROLADORES ========
            SEGUNDO PARCIAL 2011-II TERMINO
           
      Autor: Maria Auxiliadora Coronel Lainez
   
   Descripcion del proyecto: Al inicializar el programa mostrara las iniciales de mi nombre AC (Auxiliadora Coronel)
   
   PARTE I
   Lectura de los valores analgicos de un potencimetro colocado en la bornera de entrada analgica,
   presentando las variaciones de valores (en binario) en 8 LEDs y en dos displays de 7 segmentos 
   (en dos dgitos decimales) disponibles.
   
   PARTE II
   Descripcion del proyecto: Dependiendo del valor mostrado en los displays (PORTC Y PORTD)
                             Que son controladas por las botoneras RA2 y RA3
                             si el numero es par o impar este mostrara una secuencia
                             en los leds ubicados en el PORTB */

long int temp_res, temporal, num,uni_num, dec_num;
short salir=1;
unsigned short cont,conta,numero,conta2;             //declaracion de Variables Globales
char i;
unsigned short mask(unsigned short num) 
{
    switch (num) 
    {
        case 0 : return 0x3F;
        case 1 : return 0x06;
        case 2 : return 0x5B;
        case 3 : return 0x4F;
        case 4 : return 0x66;            //Retorna numeros decimales en los
        case 5 : return 0x6D;            //displays de siete segmentos
        case 6 : return 0x7D;
        case 7 : return 0x07;
        case 8 : return 0x7F;
        case 9 : return 0x6F;
    }
}

void presentacion(unsigned short numero)
{
      numero=(cont*10)+conta;
           if(((numero%2)==0)&&(numero!=0)) //si es un numero PAR en los displays
           {
             delay_ms(150);
             PORTB=0X81;
             delay_ms(150);                 // Muestra la secuencia uno
             PORTB=0X42;
             delay_ms(150);
             PORTB=0X24;
             delay_ms(150);
             PORTB=0X18;
             delay_ms(150);
             PORTB=0X24;
             delay_ms(150);
             PORTB=0X42;
             delay_ms(150);
             PORTB=0X81;
             delay_ms(150);
           }
           else if(((numero%2)==1)&&(numero!=0)){  //Si es un numero IMPAR MOSTRADO EN
             delay_ms(150);               //LOS DISPLAYS
             PORTB=0XC0;
             delay_ms(150);
             PORTB=0X30;                  // Muestra la secuencia 2
             delay_ms(150);
             PORTB=0X0C;
             delay_ms(150);
             PORTB=0X03;
             delay_ms(150);
             PORTB=0X0C;
             delay_ms(150);
             PORTB=0X30;
             delay_ms(150);
             PORTB=0XC0;
             delay_ms(150);
            }
            else{                     //Si el numero es igual a cero
            Delay_ms(150);
            PORTB=0XFF;
            }
            
}
void potenciometro()
{
               while(salir==0){
               temp_res = ADC_Read(0);  //se pregunta por la seal analogica
               temporal = (temp_res)*97;
               num      = (temporal)/1000;
               PORTB    = num;         //se muestra en binario a traves de PORTB
               dec_num  = num/(10);
               uni_num  = num-((dec_num)*10);
               PORTC    = mask(uni_num); //Se muestra las unidades en PORTC
               PORTD    = mask(dec_num); //Se muestra las decenas en PORTD
               delay_ms(50);              // Espera 50 mseg
              if(RA1_bit==1){
               salir=1;
               }
               }





}

void main()
{

     ANSEL=0x01;                    // entrada analogica para potenciometro RA0
     ANSELH=0;                      //entradas o salidas digitales
     
     PORTD=0;
     TRISD=0;                      //PORTD, PORTC Y PORTB COMO salidas digitales
     PORTB=0;                     
     TRISB=0;                     //configurando como salidas digitales
     PORTC=0;
     TRISC=0;
     PORTA=255;                      //PORTA COMO ENTRADA DIGITAL
     TRISA=255;
     
     PORTE=255;
     TRISE=255;

     //OPTION_REG = 0x80;             // Set timer TMR0
    // TMR0 = 0;

     PORTD=0X77;                //inicilaes de mi nombre A (AUXILIADORA)
     PORTC=0X39;                //iniciales de mi apellido C (CORONEL)
     Delay_MS(50);
     cont=0;
     conta=0;
     conta2=0;
     

   while(1)
    {

         if(RA1_bit==1){                          //Si el primer boton es presionado
           conta2++;                             // presenta el resultado en los leds
           if(conta2==1){             //Contador que sigue la secuencia de las unidades
           PORTC=0X3F;                       //y decenas
           PORTD=0X3F;
          // PORTB=0X00;
           }
           Delay_ms(200);
           presentacion(numero);
           }

           if (RA2_bit==1 && (conta2>=1))
            {
               Delay_ms(200);
               if(cont==10)
               cont=0;              //Boton 2 controla las decenas
               PORTD=mask(cont);
               cont++;
            }
            if (RA3_bit==1 &&(conta2>=1))                     //Boton 3 controla las unidades
            {
               Delay_ms(200);
               if(conta==10)
               conta=0;
               PORTC=mask(conta);
               conta++;
            }
            if(RA4_bit==1)   //4to boton RESETEA y empieza a funcionar
            {                 //el potenciometro
              Delay_ms(200);
              PORTC=0x3F;
              PORTD=0X3F;
              cont=0;
              conta=0;
              salir=0;
              potenciometro();
           }
     }
}
